Home | All Classes | Main Classes | Annotated | Grouped Classes | Functions |

# TQAxAggregated Class Reference
[TQAxServer module]

The TQAxAggregated class is an abstract base class for implementations of additional COM interfaces. More...

This class is part of the TQt ActiveTQt Extension.

`#include <qaxbindable.h>`

List of all member functions.

## Public Members

- virtual long queryInterface ( const TQUuid & iid, void ** iface ) = 0

## Protected Members

- IUnknown * controllingUnknown () const
- TQWidget * widget () const
- TQObject * object () const

## Detailed Description

This class is defined in the TQt ActiveTQt Extension, which can be found in the `qt/extensions` directory. It is not included in the main TQt API.

The TQAxAggregated class is an abstract base class for implementations of additional COM interfaces.

Create a subclass of TQAxAggregated and reimplement queryInterface() to support additional COM interfaces. Use multiple inheritance from those COM interfaces. Implement the IUnknown interface of those COM interfaces by delegating the calls to QueryInterface(), AddRef() and Release() to the interface provided by controllingUnknown().

Use the widget() method if you need to make calls to the TQWidget implementing the ActiveX control. You must not store that pointer in your subclass (unless you use TQGuardedPtr), as the TQWidget can be destroyed by the ActiveTQt framework at any time.

## Member Function Documentation

### IUnknown * TQAxAggregated::controllingUnknown () const`[protected]`

Returns the IUnknown interface of the ActiveX control. Implement the IUnknown interface in your TQAxAggregated subclass to delegate calls to QueryInterface(), AddRef() and Release() to the interface provided by this function.

        HRESULT AxImpl::QueryInterface( REFIID iid, void **iface )
        {
            return controllingUnknown()->QueryInterface( iid, iface );
        }

        unsigned long AxImpl::AddRef()
        {
            return controllingUnknown()->AddRef();
        }

        unsigned long AxImpl::Release()
        {
            return controllingUnknown()->Release();
        }

The TQAXAGG_IUNKNOWN macro expands to the code above, and you can use it in the class declaration of your subclass.

### TQObject * TQAxAggregated::object () const`[protected]`

Returns a pointer to the TQObject subclass implementing the COM object. This function might return 0.

Warning: You must not store the returned pointer, unless you use a TQGuardedPtr, since the TQObject can be destroyed by ActiveTQt at any time.

### long TQAxAggregated::queryInterface ( const TQUuid & iid, void ** iface )`[pure virtual]`

Reimplement this pure virtual function to support additional COM interfaces. Set the value of iface to point to this object to support the interface iid. Note that you must cast the `this` pointer to the appropriate superclass.

        long AxImpl::queryInterface( const TQUuid &iid, void **iface )
        {
            *iface = 0;
            if ( iid == IID_ISomeCOMInterface )
                *iface = (ISomeCOMInterface*)this;
            else
                return E_NOINTERFACE;

            AddRef();
            return S_OK;
        }

Return the standard COM results S_OK (interface is supported) or E_NOINTERFACE (requested interface is not supported).

Warning: Even though you must implement the IUnknown interface if you implement any COM interface you must not support the IUnknown interface in your queryInterface() implementation.

### TQWidget * TQAxAggregated::widget () const`[protected]`

Returns a pointer to the TQWidget subclass implementing the ActiveX control. This function might return 0.

Warning: You must not store the returned pointer, unless you use a TQGuardedPtr, since the TQWidget can be destroyed by ActiveTQt at any time.

This file is part of the TQt toolkit. Copyright © 1995-2007 Trolltech. All Rights Reserved.